{Copyright Francesco Savastano 2001 : This source is free , but you
 cannot distribute it , if you want others have it , let them know
 to come to my web site : http://digilander.iol.it/gensavas/francosava/
 If you put this algorithm in your free or commercial software i'd like my name in your thanx list .
 also check out my photoretouch program at : http://web.tiscalinet.it/new_world_software/ }

 {Description :unit to implement the famous magic wand algorithm : an other secret is revealed !
 the use of this unit is shown in the attached delphi sample program }

{ Az elz szerz tlete alapjn G32-es csomagra alkalmazta Mohcsi Szilveszter }
{ Teszteredmny    TImage   48342 pont 110 ms
                   TImgView 48342 pont  50 ms
  Assembly         ??????????????????????????
}
unit unitG32;



interface


uses
  Windows, SysUtils, Classes, Graphics, math,
  GR32, GR32_Image, GR32_Layers, GR32_LowLevel, GR32_Transforms;

type
  TBool2darray=array of array of boolean;

function  fill32(bitmap32: TBitmap32; a, b: integer;
                 newcolor, oldcolor: TColor32; tolerance: real;
                 fill_type: byte; intens, tras: real): longword;
procedure exec32_fill(bitmap32: TBitmap32; xf, yf: integer;
                      var nf: integer; newcolor, oldcolor: TColor32;
                      tolerance: real; fill_type: byte; intens, tras: real);


function  magicwand32(bitmap32: TBitmap32; a,b: integer;
                      newcolor, oldcolor: TColor; tolerance: real;
                      draw: boolean;
                      var fp: longword): longword;
//                      var mask:tbool2darray): integer;
procedure exec32_magn(var bitmap32: TBitmap32; xf,yf: integer;
                      var nf: integer; oldcolor: TColor32;
                      tolerance: real; var mask: TBool2darray);
function  showmagicwand32(bitmap32: TBitmap32; newcolor: TColor32; var mask: TBool2darray): longword;


implementation
type
  trgbtriplerow=array[0..30000]of trgbtriple;
  prgbtriplerow=^trgbtriplerow;

var
//  mask: array of array of boolean;
  mask: TBool2darray;
  fillx:array[0..80000]of integer;
  filly:array[0..80000]of integer;


function Valore(n1,n2,hue :real) : real;
begin
  if hue >= 360 then
    hue := hue-360
  else
    if hue < 0 then
      hue := hue+360;
  if hue>=240 then
    result := n1;
  if hue<240 then
    result := n1+(n2-n1)*(240-hue)/60;
  if hue<180 then
    result := n2;
  if hue < 60 then
    result := n1+(n2-n1)*hue/60;
end;


procedure rgb2hls (c1,c2,c3 :real;var h,l,s :real);
var delta,kmin,kmax :real;
    minmax:array[1..3] of double;
begin
  minmax[1]:=c1;
  minmax[2]:=c2;
  minmax[3]:=c3;
  kmin:= minvalue(minmax);
  kmax:=maxvalue(minmax);
  {Valuta la luminosit }
  l := (kmax+kmin)/2;
  {Valuta la saturazione}
  if kmax = kmin then
  begin
    s := 0;
    h:= 0;
  end
  else
  begin
    if l <= 0.5 then
      s := (kmax-kmin)/(kmax+kmin)
    else
      s := (kmax-kmin)/(2-kmax-kmin) ;
   {Valuta il valore di hue}
    delta := kmax-kmin ;
    if kmax = c1 then
      h := (c2-c3)/delta;
    if kmax = c2 then
      h := 2+(c3-c1)/delta;
    if kmax = c3 then
      h := 4+(c1-c2)/delta ;
    h := h*60;
    if h<0 then
      h := h+360;
  end;
end;

procedure hls2rgb (h,l,s : real ;var c1,c2,c3 : real);
var m1,m2 : real;
begin
  if l<=0.5 then
    m2 := l*(1+s)
  else
    m2 := l+s*(1-l);
  m1 := 2*l-m2;
  c1 := valore(m1,m2,h+120);
  c2 := valore(m1,m2,h);
  c3 := valore(m1,m2,h-120);
  if (s = 0) and (h = 0) then
  begin
    c1 := l;
    c2 := l;
    c3 := l;
  end;
end;

function fill32;
var nf:integer;
    i,ir:integer;
    xf,yf:integer;
begin
  SetLength( mask, bitmap32.width+5, bitmap32.height+5 );
  nf := 1;
  ir := 1;
  fillx[nf]:= a;
  filly[nf]:= b;
  exec32_fill(bitmap32,a,b,nf,newcolor,oldcolor,tolerance,fill_type,intens,tras);
  while nf>ir do
  begin
    ir := ir+1;
    xf := fillx[ir];
    yf := filly[ir];
    exec32_fill(bitmap32, xf, yf, nf, newcolor, oldcolor, tolerance, fill_type, intens, tras);
    if (nf>75000)  then
    begin
      for i := 1 to nf-ir do
      begin
        fillx[i] := fillx[ir+i];
        filly[i] := filly[ir+i];
      end;
      nf := nf-ir ;
      ir := 0;
    end;
  end;
  Result:=nf-1;
  mask:=nil;
end;


procedure exec32_fill;
//type trgbtriplerow=array[0..2000]of trgbtriple;
//     prgbtriplerow=^trgbtriplerow;
var hh,ll,ss,h1,l1,s1,aa,bb,cc:real;
    c1,c2,c3,pixr,pixg,pixb,oldr,oldg,oldb,newr,newg,newb:byte;
    pix:tcolorref;
    jj:byte;
    xr,yr:longint;
    gray:real;
    C: TColor32;
begin
  oldr:=RedComponent(oldcolor);
  oldg:=GreenComponent(oldcolor);
  oldb:=BlueComponent(oldcolor);
  newr:=RedComponent(newcolor);
  newg:=GreenComponent(newcolor);
  newb:=BlueComponent(newcolor);

  for jj:=1 to 4 do
  begin
    if jj=1 then begin
      xr:=xf+1; yr:=yf;
    end;
    if jj=2 then begin
      xr:=xf-1; yr:=yf;
    end;
    if jj=3 then begin
      xr:=xf; yr:=yf+1;
    end;
    if jj=4 then begin
      xr:=xf; yr:=yf-1;
    end;

    if ((xr< bitmap32.width)  and (jj=1)) or ((xr>=0) and (jj=2)) or
       ((yr< bitmap32.height) and (jj=3)) or ((yr>=0) and (jj=4)) then
    begin
      C:=Bitmap32.Pixel[xr,yr];
      pixr:= RedComponent(C);
      pixg:= GreenComponent(C);
      pixb:= BlueComponent(C);

      if (not mask[xr,yr])and(abs(pixr-oldr)<=tolerance*150)and(abs(pixg-oldg)<=tolerance*150)and(abs(pixb-oldb)<=tolerance*150)then
      begin

//******************************************************************************

        case fill_type of
          0 : ;
          1 : begin
                Bitmap32.Pixel[xr,yr]:=Color32(round(tras*pixr+(1-tras)*newr),
                                               round(tras*pixg+(1-tras)*newg),
                                               round(tras*pixb+(1-tras)*newb));
                Bitmap32.Pixel[xr,yr]:=newcolor;
              end;
          2 : begin
                rgb2hls(newr/255,newg/255,newb/255,h1,l1,s1);
                rgb2hls(pixr/255,pixg/255,pixb/255,hh,ll,ss);
                hls2rgb(h1,ll,ss,aa,bb,cc);
                Bitmap32.Pixel[xr,yr]:=Color32(round(aa*255), round(bb*255), round(cc*255));
              end;
          3 : begin
                aa:=pixr/255;
                bb:=pixg/255;
                cc:=pixb/255;
                aa:=aa+aa*intens;
                bb:=bb+bb*intens;
                cc:=cc+cc*intens;
              end;
          4 : begin
                aa:=pixr/255;
                bb:=pixg/255;
                cc:=pixb/255;
                aa:=aa-(1-aa)*intens;
                bb:=bb-(1-bb)*intens;
                cc:=cc-(1-cc)*intens;
              end;
          5 : begin
                aa:=pixr/255;
                bb:=pixg/255;
                cc:=pixb/255;
                gray:=(aa+bb+cc)/3;
                aa:=aa+(aa-gray)*intens;
                bb:=bb+(bb-gray)*intens;
                cc:=cc+(cc-gray)*intens;
              end;
          6 : begin
                aa:=pixr/255;
                bb:=pixg/255;
                cc:=pixb/255;
                gray:=(aa+bb+cc)/3;
                aa:=aa-(aa-gray)*intens;
                bb:=bb-(bb-gray)*intens;
                cc:=cc-(cc-gray)*intens;
              end;
          7 : begin
                aa:=pixr/255;
                bb:=pixg/255;
                cc:=pixb/255;
                c1:=round(255*intens+pixr*(1-intens));
                c2:=round(255*intens+pixg*(1-intens));
                c3:=round(255*intens+pixb*(1-intens));
                aa:=c1/255;
                bb:=c2/255;
                cc:=c3/255;
              end;
          8 : begin
                aa:=pixr/255;
                bb:=pixg/255;
                cc:=pixb/255;
                c1:=round(1*intens+pixr*(1-intens));
                c2:=round(1*intens+pixg*(1-intens));
                c3:=round(1*intens+pixb*(1-intens));
                aa:=c1/255;
                bb:=c2/255;
                cc:=c3/255;
              end;
        end;

        case fill_type of
          3..8: begin
                  if aa>1 then aa:=1;
                  if bb>1 then bb:=1;
                  if cc>1 then cc:=1;
                  if aa<0 then aa:=0;
                  if bb<0 then bb:=0;
                  if cc<0 then cc:=0;

                  Bitmap32.Pixel[xr,yr]:=Color32(round(aa*255),round(bb*255),round(cc*255));
                end;
        end;

//******************************************************************************
{
      if fill_type=0 then
        begin
//          pp[xr].rgbtred:=round(tras*pixr+(1-tras)*newr);
//          pp[xr].rgbtgreen:=round(tras*pixg+(1-tras)*newg);
//          pp[xr].rgbtblue:=round(tras*pixb+(1-tras)*newb);
          Bitmap32.Pixel[xr,yr]:=Color32(round(tras*pixr+(1-tras)*newr),
                                         round(tras*pixg+(1-tras)*newg),
                                         round(tras*pixb+(1-tras)*newb));
        end;
        if fill_type=1 then
        begin
          rgb2hls(newr/255,newg/255,newb/255,h1,l1,s1);
          rgb2hls(pixr/255,pixg/255,pixb/255,hh,ll,ss);
          hls2rgb(h1,ll,ss,aa,bb,cc);
//          pp[xr].rgbtred:=round(aa*255);
//          pp[xr].rgbtgreen:=round(bb*255);
//          pp[xr].rgbtblue:=round(cc*255);
          Bitmap32.Pixel[xr,yr]:=Color32(round(aa*255),
                                         round(bb*255),
                                         round(cc*255));
        end;
        if (fill_type>=2)and(fill_type<8) then
        begin
          aa:=pixr/255;
          bb:=pixg/255;
          cc:=pixb/255;
          if fill_type=2 then
          begin
            aa:=aa+aa*intens;
            bb:=bb+bb*intens;
            cc:=cc+cc*intens;
          end;
          if fill_type=3 then
          begin
            aa:=aa-(1-aa)*intens;
            bb:=bb-(1-bb)*intens;
            cc:=cc-(1-cc)*intens;
          end;
          if fill_type=4 then
          begin
            gray:=(aa+bb+cc)/3;
            aa:=aa+(aa-gray)*intens;
            bb:=bb+(bb-gray)*intens;
            cc:=cc+(cc-gray)*intens;
          end;
          if fill_type=5 then
          begin
            gray:=(aa+bb+cc)/3;
            aa:=aa-(aa-gray)*intens;
            bb:=bb-(bb-gray)*intens;
            cc:=cc-(cc-gray)*intens;
          end;
          if fill_type=6 then
          begin
            c1:=round(255*intens+pixr*(1-intens));
            c2:=round(255*intens+pixg*(1-intens));
            c3:=round(255*intens+pixb*(1-intens));
            aa:=c1/255;
            bb:=c2/255;
            cc:=c3/255;
          end;
          if fill_type=7 then
          begin
            c1:=round(1*intens+pixr*(1-intens));
            c2:=round(1*intens+pixg*(1-intens));
            c3:=round(1*intens+pixb*(1-intens));
            aa:=c1/255;
            bb:=c2/255;
            cc:=c3/255;
          end;

          if aa>1 then aa:=1;
          if bb>1 then bb:=1;
          if cc>1 then cc:=1;
          if aa<0 then aa:=0;
          if bb<0 then bb:=0;
          if cc<0 then cc:=0;

//          pp[xr].rgbtred:=round(aa*255);
//          pp[xr].rgbtgreen:=round(bb*255);
//          pp[xr].rgbtblue:=round(cc*255);
          Bitmap32.Pixel[xr,yr]:=Color32(round(aa*255),
                                         round(bb*255),
                                         round(cc*255));
        end;
}
//******************************************************************************

        mask[xr,yr]:=true;
        nf := nf+1;
        fillx[nf]:= xr;
        filly[nf]:= yr;
      end;
    end;
  end;
end;


function magicwand32;
var nf:integer;
    i,ir:integer;
    xf,yf:integer;
    tc: real;
begin
  SetLength( mask, bitmap32.width+5, bitmap32.height+5 );

  nf := 1;
  ir := 1;
  tc:=tolerance*150;
  fillx[nf]:= a;
  filly[nf]:= b;
  exec32_magn(bitmap32,a,b,nf,oldcolor,tc{tolerance},mask);
  while nf>ir do
  begin
    ir := ir+1;
    xf := fillx[ir];
    yf := filly[ir];
    exec32_magn(bitmap32,xf,yf,nf,oldcolor,tc{tolerance},mask);
    if (nf>75000)  then
    begin
      for i := 1 to nf-ir do
      begin
      fillx[i] := fillx[ir+i];
      filly[i] := filly[ir+i];
      end;
      nf := nf-ir ;
      ir := 0;
    end;
  end;
  if draw then
    fp:=showmagicwand32(bitmap32,newcolor,mask);

  Result:=nf-1;
  mask:=nil;
end;


procedure exec32_magn;
var hh,ll,ss,h1,l1,s1,aa,bb,cc:real;
    c1,c2,c3,pixr,pixg,pixb,oldr,oldg,oldb,newr,newg,newb:byte;
    pix:tcolorref;
    jj:byte;
    xr,yr:longint;
    gray:real;
    C: TColor32;
begin
  oldr:=RedComponent(oldcolor);
  oldg:=GreenComponent(oldcolor);
  oldb:=BlueComponent(oldcolor);

  for jj:=1 to 4 do
  begin
{    case jj of
      1: begin xr:=xf+1; yr:=yf; end;
      2: begin xr:=xf-1; yr:=yf; end;
      3: begin xr:=xf; yr:=yf+1; end;
      4: begin xr:=xf; yr:=yf-1; end;
    end;
}
    if jj=1 then begin
      xr:=xf+1; yr:=yf;
    end;
    if jj=2 then begin
      xr:=xf-1; yr:=yf;
    end;
    if jj=3 then begin
      xr:=xf; yr:=yf+1;
    end;
    if jj=4 then begin
      xr:=xf; yr:=yf-1;
    end;

    if ((xr< bitmap32.width)and(jj=1))or((xr>=0)and(jj=2)) or
       ((yr< bitmap32.height)and(jj=3))or((yr>=0)and(jj=4)) then
    begin
    //pp:=bitmap1.scanline[yr];
    //pp:=bitmap1.pixel[xr,yr];
    //pix:=rgb(pp[xr].rgbtred,pp[xr].rgbtgreen,pp[xr].rgbtblue);
      C:=Bitmap32.Pixel[xr,yr];
      pixr:= RedComponent(C);
      pixg:= GreenComponent(C);
      pixb:= BlueComponent(C);
      if (not mask[xr,yr])and(abs(pixr-oldr)<=tolerance{*150})and
         (abs(pixg-oldg)<=tolerance{*150})and(abs(pixb-oldb)<=tolerance{*150})then
      begin
        mask[xr,yr]:=true;
        nf := nf+1;
        fillx[nf]:= xr;
        filly[nf]:= yr;
      end;
    end;
  end;
end;

{This is only one of possible ways to show the result of the magic wand selection (stored in the array "mask" ) onto a bitmap ,
sorry but the selection will not be animated like you see in some photoretouch softwares ,
but i don't think this is very difficult to do !}

function showmagicwand32;
var i,j:integer;
    n: dword;
    C: TColor32;
    test:boolean;
    pp:prgbtriplerow;
begin
  n:=0;
  for j:=1 to bitmap32.height-2 do
  begin
//    pp:=bitmap32.scanline[j];
    for i:=1 to bitmap32.width-2 do
    begin
      if mask[i,j]then
      begin
        test:= mask[i-1,j] and mask[i+1,j] and mask[i,j-1] and mask[i,j+1] ;
        if not test then
        begin
          {simply invert the colors of the boundary pixels }
//          with pp[i] do
//          begin
//            rgbtred:=255-rgbtred;
//            rgbtgreen:=255-rgbtgreen;
//            rgbtblue:=255-rgbtblue;
//            Bitmap32.Pixel[i,j]:=Color32(255-rgbtred,255-rgbtred,255-rgbtred);
//          end;
//          C:=Bitmap32.Pixel[i,j];
//          if multidraw then
//            if C<>newcolor then begin
            Bitmap32.Pixel[i,j]:=newcolor;
            inc(n);
//          end;
        end;
      end;
    end;
  end;
  Result:=n;
end;


end.
